' O2ListView.inc
' contains all the O2 macros , types,  functions and constants needed by a ListView control
'  requires O2Common.inc be included prior to this file
' updated  Dec 14 2018

#Lookahead

macro ListView_InsertColumn(hwnd,iCol,pcol) (SendMessage(hwnd, LVM_INSERTCOLUMN, iCol, pcol))
macro ListView_SetColumnWidth(hwnd,iCol,cx) (SendMessage(hwnd, LVM_SETCOLUMNWIDTH, iCol, cx))
macro ListView_InsertItem(hwnd,pitem) (SendMessage(hwnd, LVM_INSERTITEM,0, pitem))
macro ListView_SetItem(hwnd,pitem) (SendMessage(hwnd, LVM_SETITEM,0, pitem))





' Type definitions

type LVCOLUMN 
  uint  mask 
  int   fmt 
  int   cx 
  char* pszText 
  int   cchTextMax 
  int   iSubItem 
  int   iImage
  int   iOrder
  int   cxMin
  int   cxDefault
  int   cxIdeal  
end type 
typedef LVCOLUMN LV_COLUMN

'  
type LVITEM  
  uint   mask 
  int    iItem 
  int    iSubItem 
  uint   state 
  uint   stateMask 
    char*  pszText               ' 
  int    cchTextMax 
  int    iImage       '// index of the list view item's icon 
  sys    lParam     '  // 32-bit value to associate with item 
  int    iIndent
  int    iGroupId
  uint   cColumns
 uint   *puColumns
 int    *piColFmt
  int     iGroup
 end type



typedef     LVITEM    LV_ITEM


type NMLISTVIEW
  NMHDR hdr
  int   iItem
  int   iSubItem
  uint  uNewState
  uint  uOldState
  uint  uChanged
  POINT ptAction
  sys   lParam
end type

typedef NMLISTVIEW    NM_LISTVIEW


' does NOT work
TYPE  NMCUSTOMDRAW 
   hdr         AS NMHDR   ' NMHDR     hdr
   dwDrawStage AS DWORD  ' DWORD     dwDrawStage
   hdc         AS sys   ' HDC       hdc
   rc            AS RECT    ' RECT      rc
   dwItemSpec  AS DWORD   ' DWORD_PTR dwItemSpec  // this is control specific, but it's how to specify an item. valid only with CDDS_ITEM bit set
   uItemState    AS UINT  ' UINT      uItemState
   lItemlParam   AS LONG    ' LPARAM    lItemlParam
END TYPE



' does NOT work
TYPE   NMLVCUSTOMDRAW 
   nmcd        AS NMCUSTOMDRAW   ' NMCUSTOMDRAW nmcd
   clrText     AS DWORD          ' COLORREF clrText
   clrTextBk   AS DWORD          ' COLORREF clrTextBk
   iSubItem    AS LONG               ' int iSubItem
   dwItemType  AS DWORD          ' DWORD dwItemType
   ' // Item custom draw
   clrFace     AS DWORD          ' COLORREF clrFace
   iIconEffect AS LONG           ' int iIconEffect
   iIconPhase  AS LONG           ' int iIconPhase
   iPartId     AS LONG           ' int iPartId
   iStateId    AS LONG           ' int iStateId
   ' // Group Custom Draw
   rcText      AS RECT         ' RECT rcText
   uAlign      AS  UINT         ' UINT uAlign  // Alignment. Use LVGA_HEADER_CENTER, LVGA_HEADER_RIGHT, LVGA_HEADER_LEFT
END TYPE



' ========================================================================================
' Changes the state of an item in a list-view control.
' ========================================================================================
SUB ListView_SetItemState (BYVAL hwndLV AS sys, BYVAL i AS LONG, BYVAL dwState AS sys, BYVAL mask AS sys)
   LOCAL lvi AS LVITEM
   lvi.stateMask = mask
   lvi.state = dwState
   SendMessage hwndLV, LVM_SETITEMSTATE, i, VARPTR(lvi)
END SUB
